#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

#month name
@MonthName = (00,
              "##MSG_MONTH01##","##MSG_MONTH02##","##MSG_MONTH03##","##MSG_MONTH04##",
              "##MSG_MONTH05##","##MSG_MONTH06##","##MSG_MONTH07##","##MSG_MONTH08##",
              "##MSG_MONTH09##","##MSG_MONTH10##","##MSG_MONTH11##","##MSG_MONTH12##",
             );
							

# ------------------------------------------- common funcion
sub FineDec($)
{
  my $val=shift;
  $val =~ s/(\d{1,3})(?=(?:\d\d\d)+(?!\d))/$1$decdelimiter/gx;
  return $val;
}

sub GetTxtDate($) {
  my $date = shift;
  $date =~ m/^(\d\d\d\d)(\d\d)(\d\d)/;
  return "$3 $MonthName[$2] $1";
}

$hFeatures{0}=1;
# -------------------------------------------- .features support
sub GetFeatures($$$) {
  my $path=shift;
  my $featuresname=shift;
  my $featuresdefault=shift;
  my $fname;
  my $fval;
  
  unless (defined $hFeatures{$path}{init}) {
    open Fftr,"<$path/.features";
    while (<Fftr>) {
      ($fname,$fval)=split;
      $fname =~ s/://;
      $hFeatures{$path}{$fname}=$fval;
    }
    close Fftr;
    $hFeatures{$path}{init}=1;
  }
  $fval=(defined $hFeatures{$path}{$featuresname})?$hFeatures{$path}{$featuresname}:$featuresdefault;
  return $fval;
}


# -------------------------------------------- Templates support
sub InitTPL($) {
 InitLANG($lang);
 my $tmp=$/;
 my $tplname=shift;
 undef $/;
 open F,"<tpl/$templatename/$tplname.html" || die "can't open template file tpl/$templatename/$tplname.html - $!\n";
   $template=<F>;
 close F;

 while ($template =~ s/<!--\s\[\[\s(.*?)\sstart-->(.*?)<!--\s\]\]\s\1\send-->/<!--###tpl_\1###-->/s) {
  $hTPL{$1}=$2;
 }
 $/=$tmp;
}

sub ReplaceTPL($$) {
  my $name=shift;
  my $value=shift;
  $hTPLreplace{$name}=$value;
}

sub ApplyTPL() {
  my $tpl;
  
  #replace repeatable block 
  foreach $tpl (keys %hTPL) {  
#    $template =~ s/(<!--###tpl_$tpl###-->)/\1$tpl{$tpl}\1/;
    $template =~ s/(<!--###tpl_$tpl###-->)/$tpl{$tpl}/;
  }
  
  $template =~ s/##COPYRIGHT##/$COPYRIGHT/;
  #replace string
  foreach $name (keys %hTPLreplace) {
    $template =~ s/##$name##/$hTPLreplace{$name}/gs;
  }

  #replace string pass 2
  foreach $name (keys %hTPLreplace) {
    $template =~ s/##$name##/$hTPLreplace{$name}/gs;
  }
  
}

sub HideTPL($) {
 #remove section <!-- HIDE $hidename start --> DELETED SECTION <!-- HIDE $hidename end -->
 my $hidename=shift;
 $template =~ s/<!--\s\HIDE $hidename\sstart\s?-->.*?<!--\sHIDE $hidename\send\s?-->//gs;
}

# -------------------------------------------- Localization support
sub InitLANG($) {
 my $langname=shift;
 my $lname;
 my $lvalue;
 open F,"<lang/$langname.lng" || die "can't open template file lang/$langname.lng - $!\n";
 while (<F>) {
  chomp;
  next if (/^#/);
  ($lname,$lvalue)=split /=/;
#  $hTPLreplace{$lname}=$lvalue;
  ReplaceTPL($lname,$lvalue);
 }
 close F;
}

1;    