#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("day_detail_grp");

$co=new CGI;

$year =$co->param('year');
$month=$co->param('month');
$day  =$co->param('day');

$daypath="$reportpath/$year$month$day";

$workperiod="$day $MonthName[$month] $year";

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$daypath");
($sec_,$min_,$hour_,$mday_,$mon_,$year_,$wday_,$yday_,$isdst_)=localtime($mtime);
$mon_++;$year_+=1900;
$workperiod .= " (##MSG_UPDATE## :: ".sprintf("%02d:%02d",$hour_,$min_)." ::  $mday_ $MonthName[$mon_] $year_)";

$topsitesurl="topsites.cgi?year=$year&month=$month&day=$day";
$bigfilesurl="bigfiles.cgi?year=$year&month=$month&day=$day";

$topsites=qq(<A href="$topsitesurl">##MSG_TOP_SITES##</A>);
$bigfiles=qq(BIG files);
if (-f "$daypath/.bigfiles") {
 $bigfiles=qq(<A href="$bigfilesurl">##MSG_BIG_FILES##</A>);
}

GetGroupFile($daypath);

open FF,"<$daypath/.total";
$totaluser=<FF>;chomp $totaluser;$totaluser=~s/^user: //;
$totalsize=<FF>;chomp $totalsize;$totalsize=~s/^size: //;

#parse file & make sorted list

$N=0;
while (<FF>) {

  $N++;
  ($user,$size,$hit)=split;

  $h{$user}{size}=$size;
  $h{$user}{hit}=$hit;
  $h{$user}{group}=$hGroup{$user};
  $h{$user}{N}=$N;
}
close FF;

$i=0;
foreach $user (sort { $h{$a}{group}<=>$h{$b}{group} || $h{$b}{size}<=>$h{$a}{size}} keys %h) {
 $outlist[$i++]=$user;
}


$outlist[$i]="END";
$h{"END"}{group}="END";
$hGroupName{"END"}=" ";
$i++;

$prev_group=$hGroupName{$outlist[$0]};
$groupsum=0;

for ($j=0;$j<$i;$j++) {
  $user=$outlist[$j];
  $size=$h{$user}{size};
  $printhit =FineDec($h{$user}{hit});
  $printsize=FineDec($size);
  $percent  =sprintf("%2.1f",int($size*1000/$totalsize)/10);
  $N        =$h{$user}{N};

  $group    =$hGroupName{$user};
  $group = "##MSG_NOT_IN_GROUP##" if ($group eq "");

  $url=qq(<A href="user_detail.cgi?year=$year&month=$month&day=$day&user=$user">$user</A>);
  $url =~ s/#/%23/;

  if ($group ne $prev_group) {
  
    $gprintsize=FineDec($groupsum);
    $gpercent  =sprintf("%2.1f",int($groupsum*1000/$totalsize)/10);

    if ($j != 0) {
      $hdepsize{$prev_group}=$groupsum;
      
      $tmp=$hTPL{groupend};
      $tmp=~s/##GROUPENDBYTES##/$gprintsize/;
      $tmp=~s/##GROUPENDPERCENT##/$gpercent/;
      $tpl{user} .= $tmp;
    }  

    $groupstarturl=qq(<A name="$group">$group</A>);
   
    $tmp=$hTPL{groupstart};
    $tmp=~s/##GROUPSTARTURL##/$groupstarturl/;
    $tpl{user} .= $tmp;

    $prev_group=$group;
    $groupsum=0;
  }
  $groupsum+=$size;

  next if ($user eq "END");

  $timeurl=qq(<A href="user_time.cgi?year=$year&month=$month&day=$day&user=$user">##MSG_TIME_LINK##</A>);
        
  $tmp=$hTPL{user};
  $tmp=~s/##USERNUM##/$N/;
  $tmp=~s/##USERURL##/$url/;
  $tmp=~s/##TIMEURL##/$timeurl/;
  $tmp=~s/##USERDEP##/$group/;
  $tmp=~s/##USERCONNECT##/$printhit/;
  $tmp=~s/##USERBYTES##/$printsize/;
  $tmp=~s/##USERPERCENT##/$percent/;
  $tpl{user} .= $tmp;
	      
}


$N=0;
foreach $dep (sort {$hdepsize{$b}<=>$hdepsize{$a}} keys %hdepsize) {
  $N++;
  $gprintsize=FineDec($hdepsize{$dep});
  $depurl=qq(<A HREF="#$dep">$dep</a>);
  $gpercent  =sprintf("%2.1f",int($hdepsize{$dep}*1000/$totalsize)/10);

  $tmp=$hTPL{grouplist};
  $tmp=~s/##GROUPLISTNUM##/$N/;
  $tmp=~s/##GROUPLISTNAMEURL##/$depurl/;
  $tmp=~s/##GROUPLISTBYTES##/$gprintsize/;
  $tmp=~s/##GROUPLISTPERCENT##/$gpercent/;
  $tpl{grouplist} .= $tmp;

}

ReplaceTPL(TOPSITESURL,$topsites);
ReplaceTPL(BIGFILESURL,$bigfiles);
ReplaceTPL(DATE,$workperiod);

ApplyTPL();
HideTPL("timereport") if ($timereport == 0);
print $template;


## subroutine -----------------------------------------
sub GetGroupFile($) {
  my $path=shift;
  my @a;
  open F,"<$path/.group";
  while (<F>) {
   chomp;
   @a=split /\t/;
   $hGroup    {$a[0]}=$a[1];
   $hGroupName{$a[0]}="$a[1]. $a[2]";
  }
}

__END__
2004-12-18 ADD :       
2005-04-09 ADD : href in RIGHT sorted list to left table
2005-04-17 ADD : TemplateEngine
2005-04-17 ADD : Add % field in group list
2005-05-01 ADD : Time Report Suppor