#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

require "lightsquid.cfg";
require "common.pl";
use CGI;

InitTPL("index");

$co=new CGI;

($tmp,$tmp,$tmp,$tmp,$mon,$tmpyear) = localtime;

$year =$co->param('year' ) || ($tmpyear+1900);
$month=$co->param('month') || sprintf("%02d",$mon+1);

if ($month ne "all") {
  $workperiod=" $MonthName[$month] $year";
} else {
  $workperiod=" $year ";
  $month="";
}

#----------------------------------- find defined month & years
@days=sort glob("$reportpath/*");


foreach $day (@days) {
  if ($day =~ m/(\d\d\d\d)(\d\d)(\d\d)/) { 
    $yearhash {$1}=1;
  }    
  if ($day =~ m/$year(\d\d)(\d\d)/) { 
    $monthhash{$1}=1;
  }    
}

##  YEAR row ______________________________________________
@yearlist=sort keys %yearhash;
$yearcnt=$#yearlist+1;
if ($yearcnt == 0) {
 print "ERROR !!!!<br>report folder '$reportpath' not contain any valid data!<br>please run lightparser.pl (year check)<br><hr>";
 exit;
}
$yearspan=12/$yearcnt;

foreach $yearname (sort keys %yearhash) {
  $yearcolor=($yearname eq $year)?qq{ bgcolor="$selectedcolor"}:""; 
  $yearurl  = qq(<a href="index.cgi?year=$yearname&month=all">$yearname</a>);

  $tmp=$hTPL{year};
  $tmp=~s/##YEARCOLSPAN##/$yearspan/;
  $tmp=~s/##YEARCOLOR##/$yearcolor/;
  $tmp=~s/##YEARURL##/$yearurl/;
  $tpl{year} .= $tmp;
}

##  MONTH row ____________________________________________

$monthtmp="01";
for ($i=1;$i<=12;$i++) {
  $monthcolor=($monthtmp eq $month)?qq{bgcolor="$selectedcolor"}:"";
  $monthurl=(defined $monthhash{$monthtmp} )?"<a href='index.cgi?year=$year\&month=$monthtmp'>$monthtmp</a>":"$monthtmp";
  $monthtmp++;

  $tmp=$hTPL{month};
  $tmp=~s/##MONTHCOLOR##/$monthcolor/;
  $tmp=~s/##MONTHURL##/$monthurl/;
  $tpl{month} .= $tmp;
}

## --

@days=sort glob("$reportpath/$year$month*");
@days=reverse @days;

if ($#days == -1) {
 print "<center>ERROR !!!!<br>no data for month >>$month<<<br>please check, or select another month<br><hr></center><hr>";
 @days[0]=1;
# exit;
}

foreach $daypath (@days) {

   open FF,"<$daypath/.total" || die "can't open file $daypath/.total<br>"; 
    $user=<FF>;chomp $user;$user=~s/^user: //;
    $size=<FF>;chomp $size;$size=~s/^size: //;
   close FF;

   $overuser=GetFeatures($daypath,"overuser","?");
   $cachehit=GetFeatures($daypath,"cachehit%","?");
   
   $cachehittotal+=$cachehit;
#   print "$cachehittotal\t$cachehit<br>";
      
   $daypath =~ m#$reportpath/(.*)#;
   $date=$1;

   $average=($user != 0)?int($size/$user):0;

   $totalsize+=$size;
   $totalaverage+=$average;
   $totaluser+=$user;
   $totaloveruser+=$overuser;

   $printaverage=FineDec($average);
   $printsize   =FineDec($size);
   $printdate   =GetTxtDate($date);


   $date =~ m/^(\d\d\d\d)(\d\d)(\d\d)/;
   
   $urlbase="day_detail.cgi?year=$1&month=$2&day=$3";
   $url =qq(<a href="$urlbase">$printdate</a>);
   $url2=qq(<a href="day_detail_grp.cgi?year=$1&month=$2&day=$3">[##MSG_GRP##]</a>);
   
   $daydate="$url ";
   $daydate .= $url2 if ($showgrouplink);
   
  
  $overuserurl=(($overuser eq "?") || ($overuser == 0))?"$overuser":qq(<a href="$urlbase&oversize=1">$overuser</a>);

  $tmp=$hTPL{day};
  $tmp=~s/##DAYDATE##/$daydate/;
  $tmp=~s/##DAYUSERS##/$user/;
  $tmp=~s/##DAYOVERUSERS##/$overuserurl/;
  $tmp=~s/##DAYBYTES##/$printsize/;
  $tmp=~s/##DAYAVERAGE##/$printaverage/;
  $tmp=~s/##DAYCACHEHIT##/$cachehit/;
  $tpl{day} .= $tmp;
}

$days=($#days+1);
if ($days==0) {$days=0.00000001;} #;-)

$printtotalsize       = FineDec($totalsize);
$printtotalaverage    = FineDec(int($totalaverage/$days));
$printaveragehit      = sprintf ("%3.2f",$cachehittotal/$days);
$printaverageuser     = int($totaluser/$days);
$printaverageoveruser = int($totaloveruser/$days);

$month="all" if ($month eq "");
$printtotalsize = "<A HREF=\"month_detail.cgi?year=$year&month=$month\"> $printtotalsize </A>";

ReplaceTPL(WORKPERIOD,$workperiod);
ReplaceTPL(TOTAL,$printtotalsize);
ReplaceTPL(TOTALAVERAGE,$printtotalaverage);
ReplaceTPL(AVERAGEHIT,$printaveragehit);
ReplaceTPL(USERAVERAGE,$printaverageuser);
ReplaceTPL(OVERUSERAVERAGE,$printaverageoveruser);

ReplaceTPL(TOP_MONTH,"<A HREF=\"topsites.cgi?year=$year&month=$month&mode=month\">##MSG_MONTH##</A>");
ReplaceTPL(TOP_YEAR,"<A HREF=\"topsites.cgi?year=$year&month=$month&mode=year\">##MSG_YEAR##</A>");

ReplaceTPL(TOTAL_MONTH,"<A HREF=\"month_detail.cgi?year=$year&month=$month\">##MSG_MONTH##</A>");
ReplaceTPL(TOTAL_YEAR,"<A HREF=\"month_detail.cgi?year=$year&month=all\">##MSG_YEAR##</A>");

ApplyTPL();
HideTPL("oversize") if ($showoversizelink == 0); 
print $template;

__END__
2004-09-01 :: FIX show only month for current year ...
2004-12-18 :: ADD if MODE == MONTH -> totalsize - link month_detail.cgi
2005-01-02 :: ADD default - current year
2005-04-14 :: ADD check empty report folder!
2005-04-17 :: ADD Template Engine 
2005-04-19 :: ADD error check, add .oversize & .cachehit field support 
2005-04-21 :: ADD Template Engine, HIDE function
2005-04-22 :: ADD move cahchehit -> .features
2005-05-01 :: ADD TopSites & Total report box