#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

# Show mont user list

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("month_detail");

$co=new CGI;

$year =$co->param('year');
$month=$co->param('month');

if ($month ne "all") {
  $workperiod="$MonthName[$month] $year";
  $filter="$year$month";
  $mode="month";
  $modename="##MSG_MONTH##";
} else {
  $workperiod="##MSG_WHOLE## $year ##MSG_YEAR##";
  $filter="$year";
  $mode="year";
  $modename="##MSG_YEAR##";
}

@daylist=glob("$reportpath/$filter*");

foreach $daypath (sort @daylist) {
  open FF,"<$daypath/.total";
  
  $totaluser=<FF>;chomp $totaluser;$totaluser=~s/^user: //;
  $totalsize=<FF>;chomp $totalsize;$totalsize=~s/^size: //;

  $grandtotalsize+=$totalsize;
  $grandtotaluser+=$totaluser;

  while (<FF>) {

    ($user,$size,$hit)=split;

    $h{$user}{size}+=$size;
    $h{$user}{hit}+=$hit;
  }  
  close FF;
}
# 

$cummulative=0;
$N=0;
foreach $user (sort {$h{$b}{size}<=>$h{$a}{size}} keys 	%h) {
  $N++;	
  $percent  =sprintf("%2.1f",int($h{$user}{size}*1000/$grandtotalsize)/10);
  $printhit =FineDec($h{$user}{hit});
  $printsize=FineDec($h{$user}{size});

  $cummulative+=$h{$user}{size};
  $printcummulativesize=FineDec($cummulative);

  $url    =qq(<A href="user_detail.cgi?year=$year&month=$month&user=$user&mode=$mode">$user</a>);
  $timeurl=qq(<A href="user_time.cgi?year=$year&month=$month&user=$user&mode=$mode">##MSG_TIME_LINK##</a>);

  $tmp=$hTPL{user};
  $tmp=~s/##USERNUM##/$N/;
  $tmp=~s/##USERURL##/$url/;
  $tmp=~s/##TIMEURL##/$timeurl/;
  $tmp=~s/##USERCONNECT##/$printhit/;
  $tmp=~s/##USERBYTES##/$printsize/;
  $tmp=~s/##USERPERCENT##/$percent/;
  $tmp=~s/##ALLUSERTOTAL##/$printcummulativesize/;
  $tpl{user} .= $tmp;
}
		
ReplaceTPL(DATE,$workperiod);
ReplaceTPL(WHOLEPERIOD,$modename);

ApplyTPL();
HideTPL("timereport") if ($timereport == 0);
print $template;

__END__
2004-12-18     : init version
2004-12-22     : add cummulative sum column
2005-01-31     : Add link User -> user month stat
2005-04-17 ADD : TemplateEngine
2005-04-19 ADD : Add skip .name: fields in .total
2005-04-25 ADD : now support YEAR report, tpl fix.
2005-05-01 ADD : time report support
