#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("topsites");

$co=new CGI;

$year       =$co->param('year');
$month      =$co->param('month');
$day        =$co->param('day');
$sortorder  =$co->param('order');
$sortorder ||='size';

$mode =$co->param('mode');

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month*";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year*";
} else {
  $mode="day";
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
}

$n=1;
$printdotflag=0;

#$workperiod="$day $MonthName[$month] $year";

$sorturl  ="topsites.cgi?year=$year&month=$month&day=$day";
$sorturl .="&mode=$mode" if ($mode ne "day");
$sorturl .="&order";

$sortconnecturl = qq(<a href='$sorturl=hits'>##MSG_CONNECT##</A>);
$sortbytesurl   = qq(<a href='$sorturl=size'>##MSG_BYTES##</A>);

$sortconnectcolor = ($sortorder eq "hits")?qq( bgcolor="$selectedcolor"):"";
$sortbytescolor   = ($sortorder eq "size")?qq( bgcolor="$selectedcolor"):"";

#@days=sort glob("$reportpath/$year$month$day/*");
@days=sort glob("$reportpath/$mask/*");
@days=reverse @days;

foreach $userpath (@days) {
   next if ($userpath =~ m/^\./);

   $userpath =~ m/\d\/(.*)$/;
   $user=$1;

   open FF,"<$userpath";
    $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;
    $total+=$totalsize;
    while (<FF>) {
      ($site,$size,$hit)=split;
      $hash{hits}{$site}+=$hit;
      $hash{size}{$site}+=$size;
    }
   close FF;
}

$whourl = "whousesite.cgi?year=$year&month=$month&day=$day";
$whourl .="&mode=$mode" if ($mode ne "day");
$whourl .="&usersite";

$N=0;
foreach $site (sort {$hash{$sortorder}{$b} <=> $hash{$sortorder}{$a}} keys  %{$hash{$sortorder}}) {

  $percent  =sprintf("%2.1f",int($hash{size}{$site}*1000/$total)/10);
#  $percent  ="0.0";
  $printhit =FineDec($hash{hits}{$site});
  $printsize=FineDec($hash{size}{$site});
  
  $siteurlwho = qq(<a href="$whourl=$site">[##MSG_WHO##]</A>);
  $siteurl    = qq(<a href="http://$site">$site</A>);

  $N++;
  
  if ($N > $topsiteslimit) {
   unless ($printdotflag) {
     $printdotflag=1;

     $tmp=$hTPL{site};
     $tmp=~s/##SITENUM##//;
     $tmp=~s/##SITEURLWHO##/\.\.\./;
     $tmp=~s/##SITEURL##/\.\.\./;
     $tmp=~s/##SITECONNECT##/\.\.\./;
     $tmp=~s/##SITEBYTES##/\.\.\./;
     $tmp=~s/##SITEPERCENT##//;
     $tpl{site} .= $tmp;

   }
   next;
  }

  $tmp=$hTPL{site};
  $tmp=~s/##SITENUM##/$N/;
  $tmp=~s/##SITEURLWHO##/$siteurlwho/;
  $tmp=~s/##SITEURL##/$siteurl/;
  $tmp=~s/##SITECONNECT##/$printhit/;
  $tmp=~s/##SITEBYTES##/$printsize/;
  $tmp=~s/##SITEPERCENT##/$percent/;
  $tpl{site} .= $tmp;
}
close FF;

if ($printdotflag) {
  $tmp=$hTPL{site};
  $tmp=~s/##SITENUM##/$N/;
  $tmp=~s/##SITEURLWHO##/$siteurlwho/;
  $tmp=~s/##SITEURL##/$siteurl/;
  $tmp=~s/##SITECONNECT##/$printhit/;
  $tmp=~s/##SITEBYTES##/$printsize/;
  $tmp=~s/##SITEPERCENT##/$percent/;
  $tpl{site} .= $tmp;
}

$totalprint=FineDec($total);

ReplaceTPL(TOTAL,$totalprint);
ReplaceTPL(SORTCONNECTURL,$sortconnecturl);
ReplaceTPL(SORTCONNECTCOLOR,$sortconnectcolor);
ReplaceTPL(SORTBYTESURL,$sortbytesurl);
ReplaceTPL(SORTBYTESCOLOR,$sortbytescolor);
ReplaceTPL(DATE,$workperiod);

ApplyTPL();
print $template;

__END__
2004-09-09 ADD : skip all files starting with .
2005-04-09 ADD : show $topsiteslimit records in log (see lightsquid.cfg)
2005-04-17 ADD : TemplateEngine
2005-05-01 ADD : month & year mode report 
