#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("user_detail");

$co=new CGI;

$year =$co->param('year');
$month=$co->param('month');
$day  =$co->param('day');
$user =$co->param('user');
$mode =$co->param('mode');

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year";
} else {
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
}

@datelist=sort glob "$reportpath/$mask*";

$calculatedtotal=0;
foreach $workday (sort @datelist) {
  open FF,"<$workday/$user" || die "can't open $daypath/$user";
  $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;

  while (<FF>) {
    ($site,$size,$hit)=split;
    $h{$site}{hit} +=$hit;
    $h{$site}{size}+=$size;
    $calculatedtotal+=$size
  }  
  close FF;
}

$N=0;
$total=0;
foreach $site (sort {$h{$b}{size} <=> $h{$a}{size}} keys %h)  {
  $N++;
  $hit=$h{$site}{hit};
  $size=$h{$site}{size};
  $total+=$size;
  $percent   =sprintf("%2.1f",int($size*1000/$calculatedtotal)/10);
  $printhit  =FineDec($hit);
  $printsize =FineDec($size);
  $printtotal=FineDec($total);

  $siteurl=qq(<A href="http://$site">$site</A>);

  $tmp=$hTPL{site};
  $tmp=~s/##NUM##/$N/;
  $tmp=~s/##SITEURL##/$siteurl/;
  $tmp=~s/##SITECONNECT##/$printhit/;
  $tmp=~s/##SITEBYTES##/$printsize/;
  $tmp=~s/##SITETOTAL##/$printtotal/;
  $tmp=~s/##SITEPERCENT##/$percent/;
  $tpl{site} .= $tmp;
  
}

$printtotalsize=FineDec($calculatedtotal);
	      
ReplaceTPL(USER,$user);
ReplaceTPL(TOTAL,$printtotalsize);
ReplaceTPL(WORKPERIOD,$workperiod);

$timeurl=qq(<A href="user_time.cgi?year=$year&month=$month&day=$day&user=$user">##MSG_TIME_LINK##</A>);
ReplaceTPL(TIMEURL,$timeurl);

      
ApplyTPL();
HideTPL("timereport") if ($timereport == 0);
print $template;
	      

__END__
2004-11-09 ADD : Total column, commulative total
2004-12-18 ADD :       
2005-01-31 ADD : New Param (month=1) if, then show whole month user report, else only selected day
2005-04-14 FIX : in CONNECT column displayed size column
2005-04-17 ADD : TemplateEngine
2005-04-25 ADD : mode=year
2005-05-01 ADD : time report link
